#!/usr/bin/env python2

import string, sys

def openfiles():
    try:
        anarfile = open(sys.argv[1], "r")
        print("anarfile opened")
        # we can get the logfile name from here
        output = open(sys.argv[2], "w")
        print("output opened")
    except IOError:
        sys.stderr.write("Error opening files!\n")
        sys.exit(1)
    return (anarfile, output)
            
def parse(lines, output):
    liter, lfile, lvals = 0, "", []
    while len(lines) > 0:
        currline = lines.pop(0) # destructively iterate over lines
        if currline.startswith("Filename"):
            print("fnfound")
            lfile = currline.split()[1]
        if currline.startswith("Cell"):
            # this is _only_ any good for the binary case
            if "!" in currline:
                lvals.append(-1) # then there hasn't been a flip here
                print "noflfound"
            else:
                lvals.append(1)  # else there has
                print "flfound"
        if currline.startswith("Iteration"):
            # then we need to write the current line and start a
            # new one for the next generated configuration
            cells = str(lvals)[1:-1]
            print cells
            output.write("%s,%s,%s\n" % (liter, lfile, cells))
            liter = currline.split()[1]
            print "newiter"
            lfile, lvals = "", []
    # and write the last line:
    cells = str(lvals)[1:-1]
    print cells
    output.write("%s,%s,%s\n" % (liter, lfile, cells))

def getheader(srcfile, output):
    veclist, nx, ny, nz, lfn = [], 1, 1, 1, ""
    mylines = srcfile.readlines()
    for line in mylines:
        if line.startswith("vector:") and "!" not in line:
            veclist.append(line.split()[1])
        if line.startswith("numx:"): nx = int(line.split(":")[1])
        if line.startswith("numy:"): ny = int(line.split(":")[1])
        if line.startswith("numz:"): nz = int(line.split(":")[1])
        if line.startswith("logfilename:"): lfn = str(line.split(":")[1])
    outln = "Iteration,Filename,"
    x,y,z = 1,1,1
    while z <= nz:
        y = 1
        while y <= ny:
            x = 1
            while x <= nx:
                for vec in veclist:
                    outln += ("[%s %s %s]%s," % (x,y,z,vec.replace(",", " ")))
                x += 1
            y += 1
        z += 1
    output.write(outln[:-1] + "\n") # lose the trailing comma...
    return lfn

def main():
    srcfile, outfile = openfiles()
    lfname = getheader(srcfile, outfile)
    try:
        print lfname
        logfile = open(lfname.strip(), "r")
    except IOError:
        sys.stderr.write("Could not open logfile!\n")
        sys.exit(3)
    lflines = logfile.readlines()
    parse(lflines, outfile)
    srcfile.close()
    outfile.close()
    logfile.close()
    
if __name__ == "__main__":
    main()
